// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// GetDeviceDatasourceInstanceGroupByIDReader is a Reader for the GetDeviceDatasourceInstanceGroupByID structure.
type GetDeviceDatasourceInstanceGroupByIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceDatasourceInstanceGroupByIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceDatasourceInstanceGroupByIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewGetDeviceDatasourceInstanceGroupByIDTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceDatasourceInstanceGroupByIDDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceDatasourceInstanceGroupByIDOK creates a GetDeviceDatasourceInstanceGroupByIDOK with default headers values
func NewGetDeviceDatasourceInstanceGroupByIDOK() *GetDeviceDatasourceInstanceGroupByIDOK {
	return &GetDeviceDatasourceInstanceGroupByIDOK{}
}

/* GetDeviceDatasourceInstanceGroupByIDOK describes a response with status code 200, with default header values.

successful operation
*/
type GetDeviceDatasourceInstanceGroupByIDOK struct {
	Payload *models.DeviceDataSourceInstanceGroup
}

func (o *GetDeviceDatasourceInstanceGroupByIDOK) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups/{id}][%d] getDeviceDatasourceInstanceGroupByIdOK  %+v", 200, o.Payload)
}
func (o *GetDeviceDatasourceInstanceGroupByIDOK) GetPayload() *models.DeviceDataSourceInstanceGroup {
	return o.Payload
}

func (o *GetDeviceDatasourceInstanceGroupByIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DeviceDataSourceInstanceGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceDatasourceInstanceGroupByIDTooManyRequests creates a GetDeviceDatasourceInstanceGroupByIDTooManyRequests with default headers values
func NewGetDeviceDatasourceInstanceGroupByIDTooManyRequests() *GetDeviceDatasourceInstanceGroupByIDTooManyRequests {
	return &GetDeviceDatasourceInstanceGroupByIDTooManyRequests{}
}

/* GetDeviceDatasourceInstanceGroupByIDTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceDatasourceInstanceGroupByIDTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *GetDeviceDatasourceInstanceGroupByIDTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups/{id}][%d] getDeviceDatasourceInstanceGroupByIdTooManyRequests ", 429)
}

func (o *GetDeviceDatasourceInstanceGroupByIDTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewGetDeviceDatasourceInstanceGroupByIDDefault creates a GetDeviceDatasourceInstanceGroupByIDDefault with default headers values
func NewGetDeviceDatasourceInstanceGroupByIDDefault(code int) *GetDeviceDatasourceInstanceGroupByIDDefault {
	return &GetDeviceDatasourceInstanceGroupByIDDefault{
		_statusCode: code,
	}
}

/* GetDeviceDatasourceInstanceGroupByIDDefault describes a response with status code -1, with default header values.

Error
*/
type GetDeviceDatasourceInstanceGroupByIDDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the get device datasource instance group by Id default response
func (o *GetDeviceDatasourceInstanceGroupByIDDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceDatasourceInstanceGroupByIDDefault) Error() string {
	return fmt.Sprintf("[GET /device/devices/{deviceId}/devicedatasources/{deviceDsId}/groups/{id}][%d] getDeviceDatasourceInstanceGroupById default  %+v", o._statusCode, o.Payload)
}
func (o *GetDeviceDatasourceInstanceGroupByIDDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetDeviceDatasourceInstanceGroupByIDDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
