// Code generated by go-swagger; DO NOT EDIT.

package lm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/logicmonitor/lm-sdk-go/models"
)

// PatchAccessGroupReader is a Reader for the PatchAccessGroup structure.
type PatchAccessGroupReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PatchAccessGroupReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPatchAccessGroupOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 429:
		result := NewPatchAccessGroupTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPatchAccessGroupDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPatchAccessGroupOK creates a PatchAccessGroupOK with default headers values
func NewPatchAccessGroupOK() *PatchAccessGroupOK {
	return &PatchAccessGroupOK{}
}

/* PatchAccessGroupOK describes a response with status code 200, with default header values.

successful operation
*/
type PatchAccessGroupOK struct {
	Payload *models.AccessGroup
}

func (o *PatchAccessGroupOK) Error() string {
	return fmt.Sprintf("[PATCH /setting/accessgroup/{id}][%d] patchAccessGroupOK  %+v", 200, o.Payload)
}
func (o *PatchAccessGroupOK) GetPayload() *models.AccessGroup {
	return o.Payload
}

func (o *PatchAccessGroupOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AccessGroup)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPatchAccessGroupTooManyRequests creates a PatchAccessGroupTooManyRequests with default headers values
func NewPatchAccessGroupTooManyRequests() *PatchAccessGroupTooManyRequests {
	return &PatchAccessGroupTooManyRequests{}
}

/* PatchAccessGroupTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PatchAccessGroupTooManyRequests struct {

	/* Request limit per X-Rate-Limit-Window
	 */
	XRateLimitLimit int64

	/* The number of requests left for the time window
	 */
	XRateLimitRemaining int64

	/* The rolling time window length with the unit of second
	 */
	XRateLimitWindow int64
}

func (o *PatchAccessGroupTooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /setting/accessgroup/{id}][%d] patchAccessGroupTooManyRequests ", 429)
}

func (o *PatchAccessGroupTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header x-rate-limit-limit
	hdrXRateLimitLimit := response.GetHeader("x-rate-limit-limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("x-rate-limit-limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header x-rate-limit-remaining
	hdrXRateLimitRemaining := response.GetHeader("x-rate-limit-remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("x-rate-limit-remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header x-rate-limit-window
	hdrXRateLimitWindow := response.GetHeader("x-rate-limit-window")

	if hdrXRateLimitWindow != "" {
		valxRateLimitWindow, err := swag.ConvertInt64(hdrXRateLimitWindow)
		if err != nil {
			return errors.InvalidType("x-rate-limit-window", "header", "int64", hdrXRateLimitWindow)
		}
		o.XRateLimitWindow = valxRateLimitWindow
	}

	return nil
}

// NewPatchAccessGroupDefault creates a PatchAccessGroupDefault with default headers values
func NewPatchAccessGroupDefault(code int) *PatchAccessGroupDefault {
	return &PatchAccessGroupDefault{
		_statusCode: code,
	}
}

/* PatchAccessGroupDefault describes a response with status code -1, with default header values.

Error
*/
type PatchAccessGroupDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the patch access group default response
func (o *PatchAccessGroupDefault) Code() int {
	return o._statusCode
}

func (o *PatchAccessGroupDefault) Error() string {
	return fmt.Sprintf("[PATCH /setting/accessgroup/{id}][%d] patchAccessGroup default  %+v", o._statusCode, o.Payload)
}
func (o *PatchAccessGroupDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *PatchAccessGroupDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
